diff --git a/src/base/core/int.c b/src/base/core/int.c
index 14683c6fa9..a22762f07d 100644
--- a/src/base/core/int.c
+++ b/src/base/core/int.c
@@ -958,7 +958,7 @@ static int int15(void)
 	}
 
     case 0x88:
-	LWORD(eax) = (EXTMEM_SIZE + HMASIZE) >> 10;
+	LWORD(eax) = xms_intdrv() ? 0 : (EXTMEM_SIZE + HMASIZE) >> 10;
 	NOCARRY;
 	break;
 
@@ -1040,7 +1040,7 @@ static int int15(void)
 		-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -
 #endif
 	    if (LO(ax) == 1) {
-	    Bit32u mem = (EXTMEM_SIZE + HMASIZE) >> 10;
+	    Bit32u mem = xms_intdrv() ? 0 : (EXTMEM_SIZE + HMASIZE) >> 10;
 	    if (mem < 0x3c00) {
 		LWORD(eax) = mem;
 		LWORD(ebx) = 0;
diff --git a/src/base/init/init.c b/src/base/init/init.c
index 7cfb2e87b6..44305b0a3a 100644
--- a/src/base/init/init.c
+++ b/src/base/init/init.c
@@ -330,18 +330,10 @@ void low_mem_init(void)
   uint32_t memsize = LOWMEM_SIZE + HMASIZE;
   uint32_t dpmi_size = dpmi_lin_mem_rsv();
   int32_t dpmi_rsv_low = config.dpmi_base;
-  const uint32_t mem_1M = 1024 * 1024;
-  const uint32_t mem_16M = mem_1M * 16;
 
   open_mapping(MAPPING_INIT_LOWRAM);
   g_printf ("DOS+HMA memory area being mapped in\n");
-  /* reserve 1Mb for XMS mappings */
-  if (memsize + EXTMEM_SIZE > mem_16M - mem_1M) {
-    error("$_ext_mem too large\n");
-    leavedos(98);
-    return;
-  }
-  lowmem = alloc_mapping(MAPPING_INIT_LOWRAM, memsize + EXTMEM_SIZE);
+  lowmem = alloc_mapping(MAPPING_INIT_LOWRAM, memsize);
   if (lowmem == MAP_FAILED) {
     perror("LOWRAM alloc");
     leavedos(98);
@@ -362,9 +354,6 @@ void low_mem_init(void)
   }
   c_printf("Conventional memory mapped from %p to %p\n", lowmem, mem_base);
 
-  if (config.xms_size)
-    config.xms_map_size = (mem_16M - (memsize + EXTMEM_SIZE)) & PAGE_MASK;
-
   ptr = smalloc(&main_pool, memsize);
   assert(ptr == mem_base);
   dpmi_rsv_low -= memsize;
@@ -380,16 +369,20 @@ void low_mem_init(void)
   }
 
   if (config.ext_mem) {
+    ptr = alloc_mapping(MAPPING_EXTMEM, EXTMEM_SIZE);
+    if (ptr == MAP_FAILED) {
+      perror("ext_mem alloc");
+      leavedos(98);
+    }
     addr = alias_mapping_high(MAPPING_EXTMEM, EXTMEM_SIZE,
-		 PROT_READ | PROT_WRITE, lowmem + memsize);
+		 PROT_READ | PROT_WRITE, ptr);
     if (addr == (dosaddr_t)-1) {
       error("failure to allocate ext mem\n");
       config.exitearly = 1;
       return;
     }
     /* memsize == base */
-    register_hardware_ram_virtual('m', memsize, EXTMEM_SIZE, lowmem + memsize,
-	    addr);
+    register_hardware_ram_virtual('m', memsize, EXTMEM_SIZE, ptr, addr);
     x_printf("Ext.Mem of size 0x%x at %#x\n", EXTMEM_SIZE, addr);
   }
 
diff --git a/src/dosext/misc/xms.c b/src/dosext/misc/xms.c
index 6363dea1f9..2c898bb962 100644
--- a/src/dosext/misc/xms.c
+++ b/src/dosext/misc/xms.c
@@ -361,6 +361,12 @@ static int xms_helper_init(void)
 
   if (!config.xms_size)
     return 0;
+  if (config.ext_mem) {
+    /* remove the mapping for external himem.sys */
+    int err = unregister_hardware_ram_virtual(LOWMEM_SIZE + HMASIZE);
+    if (err)
+      error("error unregistering ext_mem\n");
+  }
   intdrv = 1;
   return 1;
 }
@@ -459,7 +465,7 @@ void xms_helper(void)
 
 void xms_init(void)
 {
-  pgapool = pgainit(config.xms_map_size >> PAGE_SHIFT);
+  pgapool = pgainit(xms_map_size >> PAGE_SHIFT);
 }
 
 void xms_done(void)
diff --git a/src/include/emu.h b/src/include/emu.h
index 4f05bfc229..5c8d0629b9 100644
--- a/src/include/emu.h
+++ b/src/include/emu.h
@@ -265,7 +265,7 @@ typedef struct config_info {
 
        int hogthreshold;
 
-       int mem_size, ext_mem, xms_size, xms_map_size, ems_size;
+       int mem_size, ext_mem, xms_size, ems_size;
        int umb_a0, umb_b0, umb_f0, hma;
        unsigned int ems_frame;
        int ems_uma_pages, ems_cnv_pages;
diff --git a/src/include/memory.h b/src/include/memory.h
index 6def675d98..74a9b4771e 100644
--- a/src/include/memory.h
+++ b/src/include/memory.h
@@ -139,7 +139,8 @@
 #define HMASIZE (64*1024)
 #define LOWMEM_SIZE 0x100000
 #define EXTMEM_SIZE ((unsigned)(config.ext_mem << 10))
-#define xms_base (LOWMEM_SIZE + HMASIZE + EXTMEM_SIZE)
+#define xms_base (LOWMEM_SIZE + HMASIZE)
+#define xms_map_size (1024 * 1024 * 16 - xms_base)
 
 #ifndef __ASSEMBLER__
 
